import java.awt.*;
import java.awt.event.*;

public abstract class FilterAdapter
implements KeyListener
{
   static Toolkit tk = Toolkit.getDefaultToolkit();
   boolean audio = true;
   
   public FilterAdapter (Component comp)
   {
      comp.addKeyListener (this);
   }
   
   public void enableAudio (boolean status)
   {
      this.audio = status; // enable audio feedback
   }

   public abstract boolean isKeyValid (KeyEvent e);

   // implement KeyListener
   public void keyTyped (KeyEvent e)
   {
      if (e.isActionKey()) // ignore action keys
         return;
      if (isKeyValid (e))
         return;

      e.consume(); // filter this keystroke
      if (audio)
         tk.beep();
   }
   public void keyPressed  (KeyEvent e) { }
   public void keyReleased (KeyEvent e) { }
}
