
import java.awt.*;
import java.awt.event.*;

public class BasicSearch extends Frame implements ActionListener
{
    Label       searchLabel = new Label("Find:");
    TextField   searchTextField = new TextField(20);
    Label       resultsLabel = new Label("Results:");
    List        results = new List();

    Button      searchButton = new Button("Search");
    Button      cancelButton = new Button("Cancel");

    static String[] words = { "ace", "race", "mace", "pace",
                             "chase", "rice", "splice", "mice",
                             "diced", "price", "lime", "dime" };

    public BasicSearch (String title)
    {
        super(title);

        Panel searchPanel = new Panel();
        Panel resultsPanel = new Panel();
        Panel buttonPanel = new Panel();

        this.setLayout(new BorderLayout());
        searchPanel.setLayout(new FlowLayout());
        resultsPanel.setLayout(new BorderLayout());
        buttonPanel.setLayout(new FlowLayout());

        searchPanel.add(searchLabel);
        searchPanel.add(searchTextField);

        resultsPanel.add("North", resultsLabel);
        resultsPanel.add("Center", results);

        buttonPanel.add(searchButton);
        buttonPanel.add(cancelButton);

        searchButton.addActionListener(this);
        cancelButton.addActionListener(this);
        cancelButton.setEnabled(false);

        this.add("North", searchPanel);
        this.add("Center", resultsPanel);
        this.add("South", buttonPanel);

        this.setSize(300,300);
        this.setVisible(true);
    }

    public void actionPerformed (ActionEvent evt)
    {
        Object source = evt.getSource();
        boolean cancel = false;

        if (source == searchButton)
        {
            searchButton.setEnabled(false);
            cancelButton.setEnabled(true);
            results.removeAll();
            String searchText = searchTextField.getText();

            for (int i = 0; i < words.length; i++)
            {
                try
                {
                    if (Thread.interrupted())
                        throw new InterruptedException();

                    Thread.sleep(1000);
                    if (words[i].indexOf(searchText) != -1)
                        results.add(words[i]);
                }
                catch (InterruptedException ie)
                {
                    break;
                }
            }
        }
        else if (source == cancelButton)
        {
            Thread.currentThread().interrupt();
        }

        searchButton.setEnabled(true);
        cancelButton.setEnabled(false);
    }

    public static void main (String args[])
    {
        new BasicSearch("Basic Search");
    }
}