
import java.awt.*;
import java.util.*;

public class Item46_3
{
    private static int  listSize;
    private static long elapsedTime;

    public static void main (String args[])
    {
        listSize = Integer.parseInt(args[0]);
        displayLookupList(loadLookupData());
    }

    private static void displayLookupList (String items[])
    {
        Frame f = new Frame("Performance Contest");
        f.setLayout(new BorderLayout());

        Label time = new Label("Time to load " + items.length +
                               " item list: " + elapsedTime + " ms");
        java.awt.List displayList = new java.awt.List();
        for (int i = 0; i < items.length; i++)
            displayList.add(items[i]);

        f.add("North", time);
        f.add("Center", displayList);
        f.setSize(400,400);
        f.setVisible(true);
    }

    private static String[] loadLookupData ()
    {
        Enumeration preloadedData = getPreloadedData();
        String[] lookupData = null;
        Vector   temp = new Vector();

        Date startTime = new Date();
        while (preloadedData.hasMoreElements())
        {
            temp.addElement((String) preloadedData.nextElement());
        }
        lookupData = new String[temp.size()];
        temp.copyInto(lookupData);
        Date stopTime = new Date();
        elapsedTime = stopTime.getTime() - startTime.getTime();
        System.out.println("Elapsed time: " + elapsedTime + " ms");
        return (lookupData);
    }

    private static Enumeration getPreloadedData ()
    {
        int preloadedDataSize = listSize;
        Vector v = new Vector(preloadedDataSize);
        for (int i = 0; i < preloadedDataSize; i++)
            v.addElement("Item " + i);

        return (v.elements());
    }
}
